---
description: The security design of BEPSwap.
---

# Security

### Overview

BEPSwap has an extremely narrow attack surface because all state inserted in the statechain by whitelisted validators is derived from validated and finalised Binance Chain transactions. There is clear separation of concerns between all aspects of the system, and all parts of the system has byzantine fault tolerance which can tolerate malicious participants. 

Additionally the custodial risk is minimised by a regular validator churn, and the insider-risk is mitigated by signer-key bounties. 

### External Attacks

Each part of the system has a different attack surfaces. 

#### Observers

The Observers query the statechain for the latest Binance Chain block height, as well as the pool address, and begins scanning from there. Each Observer has a whitelisted `bep` address in order to post events it sees into the statechain. The Observers only responds to finalised transactions they see on the Binance Chain network, so DoS attacks are minimised since all transactions on Binance Chain cost fees. 

The Observers can post asynchronously since the Validators don't apply logic to events until a super-majority is achieved. 

Observers source their own events by maintaining their own connections to Binance Chain and the system is safe as long as the super-majority of Observers are honest. 

#### Validator

The whitelisted Validators count votes from Observers on matching Binance Chain block heights and only apply business logic once a super-majority of votes have been found. 

The Validators track Binance Chain blockheight order and retain transaction ordering. Business logic from the `xyk` formula has been [formally verified](https://github.com/runtimeverification/verified-smart-contracts/blob/master/uniswap/x-y-k.pdf). Final outgoing transactions are outputted to a single transaction array per block. All blocks finalised on the statechain are completed using the CosmosSDK, which utilises tendermint super-majority consensus. 

Validators validate all blocks in accordance with application logic and the system is safe as long as the super-majority of Validators are honest. 

#### Signer

Signers all query their replicated state on disk to determine transaction payloads to sign, before converging to Channel IDs and participating in a key-signing ceremony. All Signers are whitelisted and use the Genarro-Goldfeder algorithm to generate a threshold-signature-scheme public key with no trusted dealer. The final signed transaction is then broadcasted to Binance Chain. 

Signers source their own events by maintaining their own connections to their own state and the system is safe as long as the super-majority of Signers are honest. 

#### Full Pathway

With the heuristic that a super-majority of the Service nodes are honest, then the final outgoing transactions can only be generated by finalised logic on the statechain, which only occurs after observation events are finalised, which arederived from finalised transactions on Binance Chain. 

### Internal Attacks

The system is live up to $$n/3 - 1$$ malicious nodes \(continue to operate\), and safe up to $$n*(⅔)$$malicious nodes, at which point the nodes could steal funds. Since the early BEPSwap nodes are permissioned, then the risk of attack comes from insider attacks as opposed to a cartel. To mitigate insider attacks, bounties are placed on each signer key to generate the two following qualities:

1. Imperative for the operator to secure keys to prevent loss of funds. 
2. Incentive for the attacker to take the bounty and reveal compromised access to a signer key.

Thus participants can be sure that as long as the bounties on the keys remain unclaimed, then the only risk to the system is a $$2/3$$ cartel attack of which the risk decreases with the number of nodes. 



